Index: uspace/lib/nic/src/nic_rx_control.c
===================================================================
--- uspace/lib/nic/src/nic_rx_control.c	(revision a35b458e9db1ca95e679799dc7c1b12c83359ca3)
+++ uspace/lib/nic/src/nic_rx_control.c	(revision 36470ce8f1d0f0e1ac58746fc8bd8bf3bed80974)
@@ -145,5 +145,5 @@
  */
 void nic_rxc_unicast_get_mode(const nic_rxc_t *rxc, nic_unicast_mode_t *mode,
-	size_t max_count, nic_address_t *address_list, size_t *address_count)
+    size_t max_count, nic_address_t *address_list, size_t *address_count)
 {
 	*mode = rxc->unicast_mode;
@@ -174,5 +174,5 @@
  */
 errno_t nic_rxc_unicast_set_mode(nic_rxc_t *rxc, nic_unicast_mode_t mode,
-	const nic_address_t *address_list, size_t address_count)
+    const nic_address_t *address_list, size_t address_count)
 {
 	if (mode == NIC_UNICAST_LIST && address_list == NULL) {
@@ -189,5 +189,5 @@
 	for (i = 0; i < address_count; ++i) {
 		errno_t rc = nic_addr_db_insert(&rxc->unicast_addrs,
-			(const uint8_t *) &address_list[i].address);
+		    (const uint8_t *) &address_list[i].address);
 		if (rc == ENOMEM) {
 			return ENOMEM;
@@ -208,6 +208,6 @@
  */
 void nic_rxc_multicast_get_mode(const nic_rxc_t *rxc,
-	nic_multicast_mode_t *mode, size_t max_count, nic_address_t *address_list,
-	size_t *address_count)
+    nic_multicast_mode_t *mode, size_t max_count, nic_address_t *address_list,
+    size_t *address_count)
 {
 	*mode = rxc->multicast_mode;
@@ -238,5 +238,5 @@
  */
 errno_t nic_rxc_multicast_set_mode(nic_rxc_t *rxc, nic_multicast_mode_t mode,
-	const nic_address_t *address_list, size_t address_count)
+    const nic_address_t *address_list, size_t address_count)
 {
 	if (mode == NIC_MULTICAST_LIST && address_list == NULL)
@@ -252,5 +252,5 @@
 	for (i = 0; i < address_count; ++i) {
 		errno_t rc = nic_addr_db_insert(&rxc->multicast_addrs,
-			(const uint8_t *)&address_list[i].address);
+		    (const uint8_t *)&address_list[i].address);
 		if (rc == ENOMEM) {
 			return ENOMEM;
@@ -295,5 +295,5 @@
  */
 void nic_rxc_blocked_sources_get(const nic_rxc_t *rxc,
-	size_t max_count, nic_address_t *address_list, size_t *address_count)
+    size_t max_count, nic_address_t *address_list, size_t *address_count)
 {
 	nic_rxc_add_addr_t hs = {
@@ -321,8 +321,8 @@
  */
 errno_t nic_rxc_blocked_sources_set(nic_rxc_t *rxc,
-	const nic_address_t *address_list, size_t address_count)
-{
-	assert((address_count == 0 && address_list == NULL)
-		|| (address_count != 0 && address_list != NULL));
+    const nic_address_t *address_list, size_t address_count)
+{
+	assert((address_count == 0 && address_list == NULL) ||
+	    (address_count != 0 && address_list != NULL));
 
 	nic_addr_db_clear(&rxc->blocked_sources);
@@ -331,5 +331,5 @@
 	for (i = 0; i < address_count; ++i) {
 		errno_t rc = nic_addr_db_insert(&rxc->blocked_sources,
-			(const uint8_t *) &address_list[i].address);
+		    (const uint8_t *) &address_list[i].address);
 		if (rc == ENOMEM) {
 			return ENOMEM;
@@ -395,5 +395,5 @@
  */
 bool nic_rxc_check(const nic_rxc_t *rxc, const void *data, size_t size,
-	nic_frame_type_t *frame_type)
+    nic_frame_type_t *frame_type)
 {
 	assert(frame_type != NULL);
@@ -449,7 +449,7 @@
 	if (!rxc->vlan_exact && rxc->vlan_mask != NULL) {
 		vlan_header_t *vlan_header = (vlan_header_t *)
-			((uint8_t *) data + 2 * ETH_ADDR);
+		    ((uint8_t *) data + 2 * ETH_ADDR);
 		if (vlan_header->tpid_upper == VLAN_TPID_UPPER &&
-			vlan_header->tpid_lower == VLAN_TPID_LOWER) {
+		    vlan_header->tpid_lower == VLAN_TPID_LOWER) {
 			int index = ((int) (vlan_header->vid_upper & 0xF) << 5) |
 			    (vlan_header->vid_lower >> 3);
@@ -476,5 +476,5 @@
  */
 void nic_rxc_hw_filtering(nic_rxc_t *rxc,
-	int unicast_exact, int multicast_exact, int vlan_exact)
+    int unicast_exact, int multicast_exact, int vlan_exact)
 {
 	if (unicast_exact >= 0)
@@ -505,21 +505,21 @@
 {
 	uint32_t crc;
-    int carry, i, j;
-    uint8_t b;
-
-    crc = 0xffffffff;
-    for (i = 0; i < 6; i++) {
-        b = addr[i];
-        for (j = 0; j < 8; j++) {
-            carry = ((crc & 0x80000000L) ? 1 : 0) ^ (b & 0x01);
-            crc <<= 1;
-            b >>= 1;
-            if (carry)
-                crc = ((crc ^ CRC_MCAST_POLYNOMIAL) | carry);
-        }
-    }
-
-    uint64_t one64 = 1;
-    return one64 << (crc >> 26);
+	int carry, i, j;
+	uint8_t b;
+
+	crc = 0xffffffff;
+	for (i = 0; i < 6; i++) {
+		b = addr[i];
+		for (j = 0; j < 8; j++) {
+			carry = ((crc & 0x80000000L) ? 1 : 0) ^ (b & 0x01);
+			crc <<= 1;
+			b >>= 1;
+			if (carry)
+				crc = ((crc ^ CRC_MCAST_POLYNOMIAL) | carry);
+		}
+	}
+
+	uint64_t one64 = 1;
+	return one64 << (crc >> 26);
 }
 
@@ -571,5 +571,5 @@
 		break;
 	case NIC_MULTICAST_PROMISC:
-		return ~ (uint64_t) 0;
+		return ~(uint64_t) 0;
 	}
 	uint64_t hash;